"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetFileMimeType = exports.ChangeExtension = exports.GetJsonExtensionFromHtml = exports.GetFileExtension = exports.ReduceFileData = void 0;
function ReduceFileData(files) {
    return files.reduce(function (a, b) {
        return a.concat(b);
    }, []);
}
exports.ReduceFileData = ReduceFileData;
function GetFileExtension(file) {
    var index = file.lastIndexOf('.');
    if (index < 0)
        return '';
    return file.substring(index + 1);
}
exports.GetFileExtension = GetFileExtension;
function GetJsonExtensionFromHtml(file) {
    var index = file.lastIndexOf('.html');
    return file.substring(0, index) + ".json";
}
exports.GetJsonExtensionFromHtml = GetJsonExtensionFromHtml;
function ChangeExtension(file, pre, post) {
    var index = file.lastIndexOf("." + pre);
    return file.substring(0, index) + "." + post;
}
exports.ChangeExtension = ChangeExtension;
function GetFileMimeType(extension) {
    switch (extension) {
        case "png": return "image/png";
        case "jpg":
        case "jpeg": return "image/jpeg";
        case "svg": return "image/svg+xml";
        case "json": return "application/json";
        case "xml": return "application/xml";
        case "ico": return "image/ico";
        default: return "text/plain";
    }
}
exports.GetFileMimeType = GetFileMimeType;
//# sourceMappingURL=file.functions.js.map