"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateScript = exports.CreateStyle = exports.CreateMinifiedBundleTags = exports.CreateBundleTags = void 0;
function CreateBundleTags(bundles) {
    return bundles
        .map(function (bundle) {
        if (bundle.type == 'css') {
            return bundle.files.map(function (file) { return CreateStyle(file); });
        }
        else {
            return bundle.files.map(function (file) { return CreateScript(file); });
        }
    })
        .reduce(function (a, b) {
        return a.concat(b);
    }, [])
        .reduce(function (a, b) {
        return "" + a + (a == '' ? '' : '\r\n') + b;
    }, '');
}
exports.CreateBundleTags = CreateBundleTags;
function CreateMinifiedBundleTags(bundles) {
    return bundles
        .map(function (bundle) {
        if (bundle.type == 'css') {
            return "" + CreateStyle(bundle.name + ".min.css");
        }
        else {
            return "" + CreateScript(bundle.name + ".min.js");
        }
    })
        .reduce(function (a, b) {
        return "" + a + (a == '' ? '' : '\r\n') + b;
    }, '');
}
exports.CreateMinifiedBundleTags = CreateMinifiedBundleTags;
function CreateStyle(path) {
    return "<link rel=\"stylesheet\" type=\"text/css\" href=\"/" + path + "\">";
}
exports.CreateStyle = CreateStyle;
function CreateScript(path) {
    return "<script type=\"text/javascript\" src=\"/" + path + "\"></script>";
}
exports.CreateScript = CreateScript;
//# sourceMappingURL=handlebars.functions.js.map